/*
 * C
 *
 * Copyright 2019 MicroEJ Corp. All rights reserved.
 * For demonstration purpose only.
 * MicroEJ Corp. PROPRIETARY. Use is subject to license terms.
 */

#include "qb_impl.h"
#include "fsl_debug_console.h"

#ifdef TEST_QUALIFICATION_BUNDLE

#include "t_core_main.h"
#include "t_ui_main.h"

void QB_IMPL_run_tests(void)
{
    int64_t time;
	double speed;
    uint32_t* p;
    volatile uint32_t value;
	UTIL_TIME_BASE_initialize();
    time = UTIL_TIME_BASE_getTime();
    for(p = (uint32_t*)0x00000400; p < (uint32_t*)0x0007FFFF; p++)
    {
        value = (*p);
    }
    time = UTIL_TIME_BASE_getTime() - time;
    
    speed = (0x0007FFFF - 0x00000400) / time;   /* bytes per us */
    speed *= 1000.0;                /* bytes per ms */
    speed *= 1000.0;                /* bytes per  s */

    PRINTF("Flash read speed %f B/s\n", speed);
    
	T_CORE_main();
	T_UI_main();
}

//void UTIL_print_initialize(void)
//{
	
//}

void stdimpl_print(const char *string)
{
    PRINTF("%s",string);
}

void UTIL_print_string(const char* string)
{
	PRINTF("%s",string);
}

void UTIL_print_integer(int integer)
{
	PRINTF("%i",integer);
}

void UTIL_print_float(double value)
{
	PRINTF("%f",value);
}

void UTIL_print_longlong(long long value)
{
	PRINTF("%llu",value);
}

#else

void QB_IMPL_run_tests(void)
{
	// nothing to test
}

#endif // TEST_QUALIFICATION_BUNDLE
